//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//>> URL Declarations
var URL = new Object;
URL.BaG_Website = "http://www.buildagadget.com/";
URL.BaG_Support = "http://www.buildagadget.com/Support-General.php";
URL.BaG_Twitter = "http://twitter.com/buildagadget";
URL.BaG_Donate = "http://buildagadget.com/Donate.php";
URL.BaG_iFrameT = "http://www.buildagadget.com/Gadgets/Core/Ad/Test.php";
URL.BaG_iFrameA = "http://www.buildagadget.com/Gadgets/Core/Ad/Control.php?Gadget=Countdown&Item=";


//>> Timers
var Timer_Count = '';

//>> Settings File
System.Gadget.settingsUI = "Settings.html";

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//*************************************************************
//  GADGET >> Initialize
//  PARAMS >> None
//*************************************************************
function GADGET_Init()
{	
	UTIL_STOR_Load();
	GADGET_Countdown();

	
	if (UTIL_VAR_Read("Message",'') != '')
		$_HTML("UI-Message", " " + UTIL_VAR_Read("Message", ''));

	if (UTIL_VAR_Read("Count_Date", '') != '')
	{
		if (Timer_Count)
			clearInterval(Timer_Count);
		Timer_Count = setInterval(GADGET_Countdown, 50);          // I'd like this to be longer, but the seconds don't update as nicely.
	}
			
	//>> Load Theme
	//>> Load Theme
	var Theme_Type = UTIL_VAR_Read("Theme_Type", "Standard");
	var Theme_Custom = UTIL_VAR_Read("Theme_Custom", '');
	var Theme_Preset = UTIL_VAR_Read("Theme_Preset", "1");

	if (Theme_Type == "Custom" && Theme_Custom != '')
		$B_BG("url('" + Theme_Custom + "') repeat-y");
	else
		$B_BG("url('Images/Themes/BG-Theme-" + Theme_Preset + ".jpg') repeat-y");
	

	//>> Set Font Styles
	var Font_Family = UTIL_VAR_Read("Font_Family", "Arial");
	var Font_Type = UTIL_VAR_Read("Font_Type", "Bold");
	var Font_Color = UTIL_VAR_Read("Font_Color", "#DDD");


	$("UI-Body").style.fontFamily = Font_Family;
	if (Font_Type == "Bold")
	{
		$("UI-Body").style.fontWeight = "bold";
	}
	else if (Font_Type == "Italic")
	{
		$("UI-Body").style.fontStyle = "italic";
	}
	else if (Font_Type == "Normal")
	{
		$("UI-Body").style.fontStyle = "normal";
	}


	$("UI-Body").style.color = Font_Color;
	$B_AdjustHeight();
}

//*************************************************************
//  GADGET >> Countdown
//  PARAMS >> None
//*************************************************************
function GADGET_Countdown()
{
	//>> Get Variables
	var Time_Hour = UTIL_VAR_Read("Time_Hour", "0");
	var Time_Minute = UTIL_VAR_Read("Time_Minute", "0");
	var Time_AMPM = UTIL_VAR_Read("Time_AMPM", "AM");
	var Count_Date = UTIL_VAR_Read("Count_Date", '');
	
	if (Count_Date != '')
	{	
		//>> Determine Difference
		var Date_Target = new Date(Count_Date + " " + Time_Hour + ":" + Time_Minute + " " + Time_AMPM);
		var Date_Now = new Date();
		var Date_Diff = new Date(Date_Target - Date_Now);
		var Date_Secs = Math.floor(Date_Diff.valueOf() / 1000);
   
		//>> Setup Display
		if (Date_Secs <= 0)
		{
			GADGET_Counter_End();
		}
		else
		{
			var xDays = GADGET_Calc_Count(Date_Secs, 86400, 100000);
			var xHours = GADGET_Calc_Count(Date_Secs, 3600, 24);
			var xMinutes = GADGET_Calc_Count(Date_Secs, 60, 60);
			var xSecs = GADGET_Calc_Count(Date_Secs, 1, 60) + 1;
			GADGET_Counter_Display(xDays, xHours, xMinutes, xSecs);
		}
	}
	else
	{
		$_Hide("UI-Count");
		var str = "<span style='font-size: 10px;'>";
			str += "            ";
			str += "</span>";
		$_HTML("UI-Message", str);
	}
}

/**************************************************************
//	GADGET >> Display Counter
**************************************************************/

function GADGET_Counter_Display (xDays, xHours, xMinutes, xSecs)
{
	$_Show("UI-Count");
	$_SetBGImage("UI-Count", "url('../Images/Misc/CounterPad.png') center 20px no-repeat");
	var Str = "<div class='Count-Outer'>";
		Str += "<span class='Count-Sub'></span>";
	Str += "<span class='Count-Sub'></span>";
	Str += "<span class='Count-Sub'></span>";
	Str += "<span class='Count-Sub'></span>";


	Str += "</div>";
	Str += "<div class='Count-Outer'>"
		Str += "<div class='Count'>" + xDays + "</div>";
		Str += "<div class='Count-Colon'>:</div>";
		Str += "<div class='Count'>" + xHours + "</div>"; 
		Str += "<div class='Count-Colon'>:</div>";
		Str += "<div class='Count'>" + xMinutes + "</div>";
		Str += "<div class='Count-Colon'>:</div>";
		Str += "<div class='Count'>" + xSecs + "</div>";
	Str += "</div>";			// Dirty hack. I hope to fix this later.
	$_Show("UI-Message");
	$_HTML("UI-Count", Str);
}

/**************************************************************
//	GADGET >> Display Counter End
**************************************************************/

function GADGET_Counter_End()
{
	var Str = "<span style='font-size: 16px;'><strong> !</strong><br>";
	Str += UTIL_VAR_Read("Message", '');
	Str += "</span>";
	$_RemoveBGImage("UI-Count");
	$_Hide("UI-Message");
	$_HTML("UI-Count", Str);
	$B_AdjustHeight();
	return;
}

//*************************************************************
//  GADGET >> Calc Count
//  PARAMS >> Secs (Int), Num1 (Int), Num2 (Int)
//*************************************************************
function GADGET_Calc_Count(Secs, Num1, Num2)
{
	return ((Math.floor(Secs / Num1)) % Num2);
}

function GADGET_Calc_Secs (Days, Hours, Min, TotSecs)
{
	TotSecs - Days - Hours - Min
}